package com.ejie.ab79.dao.listados;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.listados.Busquedas;
import com.ejie.ab79.model.listados.Parametros;

/**
 * 
 *  
 *
 */

@Repository
@Transactional
public class ParametrosDaoImpl implements ParametrosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "VALOR" };

	private JdbcTemplate jdbcTemplate;

	private RowMapper<Parametros> rwMap = new RowMapper<Parametros>() {
		public Parametros mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Parametros parametros = new Parametros();
			parametros.setIdParametro(resultSet.getInt("IDPARAMETRO"));
			parametros.setNombre(resultSet.getString("NOMBRE"));
			parametros.setTextoMostrar(resultSet.getString("TEXTOMOSTRAR"));
			parametros.setTextoMostrarEus(resultSet.getString("TEXTOMOSTRAREUS"));
			parametros.setTipoParametro(resultSet.getInt("TIPOPARAMETRO"));

			/* Busqueda */
			Busquedas busquedasAux = new Busquedas();
			busquedasAux.setIdBusqueda(resultSet.getInt("IDBUSQUEDA"));
			parametros.setBusquedas(busquedasAux);

			return parametros;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Finds rows in the Parametros table using like.
	 *
	 * @param parametros
	 *            Parametros
	 * 
	 * @return List<Parametros>
	 */
	@Transactional(readOnly = true)
	public List<Parametros> findByBusqueda(Parametros parametros) {

		StringBuilder query = new StringBuilder();
		List<Object> params = new ArrayList<Object>();

		query.append(
				"SELECT  t1.ID_PARAMETRO IDPARAMETRO, t1.ID_BUSQUEDA IDBUSQUEDA, t1.TIPO_PARAMETRO TIPOPARAMETRO, t1.NOMBRE NOMBRE, t1.TEXTO_MOSTRAR TEXTOMOSTRAR, t1.TEXTO_MOSTRAR_EUS TEXTOMOSTRAREUS");
		query.append(" FROM PARAMETROS t1 ");
		query.append("WHERE t1.ID_BUSQUEDA = ?");
		params.add(parametros.getBusquedas().getIdBusqueda());

		return (List<Parametros>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
